## metview 5.1.0

=== scripts/CMakeLists.txt ===

set(scripts
    dump metview-mail mvrun mvrun_c mvrun_lnx
    logrun metview_stat metview_create_user_dir
    metview_patches
    mvusage metview_help set_mars_env
    document_macros.pl mv_grib_dump
    metview_local.${MV_ENVIRON} metview_local2.${MV_ENVIRON}
    MarsTiggeWrapper
    MarsOdbWrapper
    generate_video
    mv_compress mv_mail mv_uniquename
    mv_odbsql mv_obstat
    mv_mars_catalog.py
    mv_flextra_prep.mv mv_flextra_prep mv_flextra_run
    mv_flexpart_run mv_flexpart_pp
    mv_met3d_prep.mv
    mv_rttov_run
    mv_scm_run mv_scm_vis.mv
    mv_vapor_prep.mv mv_vapor_gui
    select_mars_config
)

if(AT_ECMWF)
    list(APPEND scripts mv_debug_env.sh metgram.py)
endif()

if(HAVE_PPROC_MIR)
    list(APPEND scripts MarsMirWrapper DivrotMirWrapper)
endif()



# handle these script files
metview_script_files(SCRIPT_FILES ${scripts})



# remove unnecessary items from a colon-separated list (e.g. /usr/lib64, which can interfere if we use non-default compilers)
function(removeUnwantedCompileItemsFromColonString colonString)
    string (REPLACE ":"  ";"   LOC_AS_LIST "${${colonString}}")
    list(REMOVE_ITEM LOC_AS_LIST "/usr/lib")
    list(REMOVE_ITEM LOC_AS_LIST "/usr/lib64")
    string (REPLACE ";"  ":"   LOC_AS_STRING "${LOC_AS_LIST}")
    set (${colonString} ${LOC_AS_STRING} PARENT_SCOPE)
endfunction()


# remove non-compiler items and unnecessary items from the string
function(removeUnwantedCompileItems compileList)
    set(loc ${${compileList}})
    list(REMOVE_ITEM loc "debug")        
    list(REMOVE_ITEM loc "optimized")
    list(REMOVE_ITEM loc "/usr/lib")
    list(REMOVE_ITEM loc "/usr/lib64")
    list(REMOVE_ITEM loc "-L/usr/lib")
    list(REMOVE_ITEM loc "-L/usr/lib64")
    list(REMOVE_ITEM loc "-Wl,-rpath,/usr/lib")
    list(REMOVE_ITEM loc "-Wl,-rpath,/usr/lib64")

    # items could themselves be lists, e.g. rpath=/usr/lib:/usr/local/lib
    foreach (item ${loc})
        set(item1 ${item})
        removeUnwantedCompileItemsFromColonString(item1)
        list(APPEND final_result ${item1})
    endforeach()

    set (${compileList} ${final_result} PARENT_SCOPE)
endfunction()


function(removeUnwantedCompileItemsFromString compileString)
    # convert from string to list, remove items, then convert back to string
    string (REPLACE " "  ";"   LOC_AS_LIST "${${compileString}}")
    removeUnwantedCompileItems(LOC_AS_LIST)
    string (REPLACE ";"  " "   LOC_AS_STRING "${LOC_AS_LIST}")
    set (${compileString} " ${LOC_AS_STRING}" PARENT_SCOPE) # preserve leading space
endfunction()



##############################################################
#
# generate the 'compile' script for inline C/Fortran in Macro




# for GRIB_API, we *might* get something like
# grib_api;grib_api_f77;grib_api_f90;/usr/lib64/libjasper.so;/usr/lib64/libjpeg.so;/usr/lib64/libm.so
# which is not all that we need to link. So we convert 'grib_api' into '-lgrib_api'
# and for the Fortran libraries.

set(GRIB_API_LIBRARIES_STR " ${GRIB_API_LIBRARIES}") # add a space to the beginning

string (REPLACE ";"         " "           GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
if( ECCODES_FOUND )
  string (REPLACE " eccodes"  " -leccodes"  GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR}")
else()
  string (REPLACE " grib_api" " -lgrib_api" GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR}")
endif()


set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${PTHREAD_LIB}") # add pthread in case needed


# we may need to add the netCDF lib dir to the rpath. We don't seem to have a variable
# which tells us this directly, so we need to make an educated guess...
if(DEFINED NETCDF_INCLUDE_DIR)
    set(NETCDF_LIB_RPATH "-Wl,-rpath,${NETCDF_INCLUDE_DIR}/../lib64:${NETCDF_INCLUDE_DIR}/../lib")
    set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${NETCDF_LIB_RPATH}")
endif()

set(GRIB_API_LIBRARIES_STR_ORIGINAL "${GRIB_API_LIBRARIES_STR}")       # keep a backup for later


# if we are linking with shared GRIB_API libraries, then in order to be able
# to run compiled inline Fortran/C/Macro programs, we will need to set
# LD_LIBRARY_PATH to where GRIB_API was installed (this should only be
# needed if GRIB_API was installed in a non-default location).

# first, if GRIB_API_PATH is not defined, then we need to compute the path
set( grib_handling_pkg grib_api )
if( ECCODES_FOUND )
  set( grib_handling_pkg eccodes )
endif()
if(NOT GRIB_API_PATH)
    get_property(GRIB_LIB_PATH TARGET ${grib_handling_pkg} PROPERTY LIBRARY_OUTPUT_DIRECTORY)
    if(GRIB_LIB_PATH)
        set(GRIB_API_PATH ${GRIB_LIB_PATH}/..)
    else()
        if (grib_api_BASE_DIR)
            set(GRIB_API_PATH ${grib_api_BASE_DIR})
        else()
            if(CMAKE_PREFIX_PATH)
                set(GRIB_API_PATH ${CMAKE_PREFIX_PATH})
            endif()
        endif()
    endif()
    ecbuild_info("Computed GRIB_PATH: ${GRIB_API_PATH}")
endif()


if(GRIB_API_PATH)
    set(GRIB_API_RPATH "${GRIB_API_PATH}/lib:${GRIB_API_PATH}/lib64")
endif()


# for each of the GRIB library's dependencies, we should find the directory name
# and add it to the -L and to the rpath

foreach (gtpl ${GRIB_API_TPL_LIBRARIES})
    get_filename_component(gtpl_i ${gtpl} PATH)  # DIRECTORY only in CMake > 2.8.12+
    list(APPEND GRIB_LIB_TPL_DIRS ${gtpl_i})
endforeach()

if (GRIB_LIB_TPL_DIRS)
    list(REMOVE_DUPLICATES GRIB_LIB_TPL_DIRS)
    string (REPLACE ";" ":"   GRIB_LIB_TPL_RPATH    "${GRIB_LIB_TPL_DIRS}")
endif()
set(GRIB_API_RPATH "${GRIB_API_RPATH}:${GRIB_LIB_TPL_RPATH}")

set(GRIB_API_LIBRARIES_STR "-L${GRIB_API_PATH}/lib -L${GRIB_API_PATH}/lib64 -Wl,-rpath,${GRIB_API_RPATH} ${GRIB_API_LIBRARIES_STR}")
removeUnwantedCompileItemsFromString(GRIB_API_LIBRARIES_STR)


# add the GRIB include directories to the compiler directives

foreach (inc ${GRIB_API_INCLUDE_DIRS})
    set(GRIB_API_INCLUDE_DIRS_STR "${GRIB_API_INCLUDE_DIRS_STR} -I${inc}")
endforeach()


list(APPEND METVIEW_INLINE_DEFINITIONS ${GRIB_API_DEFINITIONS})


#
# something similar for libemos
#

# find the actual path to the emoslib library
get_property(EMOS_LIB_PATH TARGET emos PROPERTY LOCATION)
list(REMOVE_ITEM EMOS_LIB_PATH "debug")     # remove non-compiler items from the string
list(REMOVE_ITEM EMOS_LIB_PATH "optimized") # remove non-compiler items from the string
string (REPLACE ";"         " "           EMOS_LIBRARIES_STR        "${EMOS_LIB_PATH}")

if(LIBEMOS_PATH)
    set(EMOS_LIBRARIES_STR "-L${LIBEMOS_PATH}/lib -L${LIBEMOS_PATH}/lib64 -Wl,-rpath,${LIBEMOS_PATH}/lib:${LIBEMOS_PATH}/lib64 ${EMOS_LIBRARIES_STR}")
    # message(STATUS "${EMOS_LIBRARIES_STR}")
endif()

foreach (inc ${LIBEMOS_INCLUDE_DIRS})
    set(LIBEMOS_INCLUDE_DIRS_STR "${LIBEMOS_INCLUDE_DIRS_STR} -I${inc}")
endforeach()

list(APPEND METVIEW_INLINE_DEFINITIONS ${LIBEMOS_DEFINITIONS})

set(LIBEMOS_TPL_LIBS_COPY " ${LIBEMOS_TPL_LIBRARIES}") # add a space to the beginning
removeUnwantedCompileItems(LIBEMOS_TPL_LIBS_COPY)

foreach(elib ${LIBEMOS_TPL_LIBS_COPY})
    get_filename_component(elibpath ${elib} PATH)
    if("${elibpath}" STREQUAL "")
        string(FIND ${elib} "-l" MINUS_L_POS)
        if(MINUS_L_POS EQUAL -1) # does not start with -l
            set(ELIB_TPL_STR "${ELIB_TPL_STR} -l${elib}")
        else()
            set(ELIB_TPL_STR "${ELIB_TPL_STR} ${elib}")
        endif()
    else()
        string(STRIP ${elibpath} ELIBPATH_STRIPPED)
        set(ELIB_TPL_STR "${ELIB_TPL_STR} -L${ELIBPATH_STRIPPED} -Wl,-rpath,${ELIBPATH_STRIPPED} ${elib}")
    endif()
endforeach()

removeUnwantedCompileItemsFromString(EMOS_LIBRARIES_STR)
removeUnwantedCompileItemsFromString(ELIB_TPL_STR)

#
# something similar for fdb
#

if(FDB_FOUND)
    if(FDB_LIBRARY)  # fdb in bundle
        get_filename_component(FDB_LIB_DIR ${FDB_LIBRARY} PATH)
        set(FDB_LIBRARIES_STR "${FDB_LIBRARY} -Wl,-rpath,${FDB_LIB_DIR}")
    else()           # fdb not in bundle
        foreach(fdblib ${FDB_LIBRARIES})
            set(FDB_MINUS_L_LIBS " -l${fdblib} ${FDB_MINUS_L_LIBS}")
        endforeach()
        set(FDB_LIBRARIES_STR "")
        set(libdirs lib lib64)
        foreach(libdir ${libdirs})
            set(FDB_LIBRARIES_STR "-Wl,-rpath,${fdb_BASE_DIR}/${libdir} -L${fdb_BASE_DIR}/${libdir} ${FDB_LIBRARIES_STR}")
        endforeach()
        set(FDB_LIBRARIES_STR "${FDB_MINUS_L_LIBS} ${FDB_LIBRARIES_STR}")
    endif()
endif()


# in the case of a static libemos, we may need to be explicit about about the Fortran libraries when
# building inline C
foreach(fortlib ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES})
    set(IMPLICIT_FORTRAN_LIBS "-l${fortlib}  ${IMPLICIT_FORTRAN_LIBS}")
endforeach()



configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile @ONLY)



# in the case of a bundle, the GRIB_API and emoslib locations will have been
# set to their build directories, which is correct when running from 
# the build directory, but not once installed, so we have to change these
# to the location where they will be installed, and create another 'compile'
# script which is the one that will actually be installed. In the case where
# we're not building a bundle, these two compile scripts will be identical.

# this checks if ECCODES is inside a bundle with us
if(DEFINED METVIEW_BUNDLE OR METVIEW_BUNDLE_TYPE STREQUAL "MMG")
    set(GRIB_API_LIBRARIES_STR    "-L${CMAKE_INSTALL_PREFIX}/lib ${GRIB_API_LIBRARIES_STR_ORIGINAL}")
    set(GRIB_API_INCLUDE_DIRS_STR "-I${CMAKE_INSTALL_PREFIX}/include")
    set(GRIB_API_PATH ${CMAKE_INSTALL_PREFIX})
endif()


# this checks if ECCODES is inside a bundle with us
if(DEFINED METVIEW_BUNDLE OR METVIEW_BUNDLE_TYPE STREQUAL "MM")
	string(REPLACE "${CMAKE_BINARY_DIR}/lib"  "${CMAKE_INSTALL_PREFIX}/lib"  EMOS_LIBRARIES_STR  "${EMOS_LIBRARIES_STR}")
endif()


# it would be nice to be a bit neater here, but this aspect is hard-coded in ecCodes
# and the fact that the path for MMFS definitions is in /MEMFS is not accessible
# from CMake, so we need to duplicate that piece of information here

if(ECCODES_HAVE_MEMFS)
    set(GRIB_API_SHARE_DIR "/MEMFS")
else()
    set(GRIB_API_SHARE_DIR "${GRIB_API_PATH}/share/${grib_handling_pkg}")
endif()



configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile_install @ONLY)



install( FILES ${CMAKE_BINARY_DIR}/bin/compile_install  
         DESTINATION ${MV_BIN_DIR}
         RENAME      compile
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)




##################
#
# CONFIG.site

if( DEFINED NETCDF_PATH )
    set(NETCDF_BIN "${NETCDF_PATH}/bin")
else()
    set(NETCDF_BIN "")
endif()

if(DEFINED METVIEW_BUNDLE)
    set(METVIEW_BUNDLE_SRC ${CMAKE_SOURCE_DIR})
endif()

if(DEFINED METVIEW_BUNDLE_MAGICS)
    set(MV_BUNDLE_MAGICS_SRC ${CMAKE_SOURCE_DIR}/magics)
endif()



ecbuild_get_date(TODAYS_DATE)


# # Add certain paths to LD_LIBRARY_PATH.
# # If the given path is not a standard system one, then add it to our list
# # of paths to add to LD_LIBRARY_PATH on Metview's startup. We want to
# # avoid adding system paths here because they can override non-default
# # paths (case in point: the wrong OpenGL library has been known to be
# # picked up - used by VAPOR).
#
# NO - this is not really needed with the rpath, and it can lead, in the
# case of a bundle, to the build directory (Magics) going into the
# LD_LIBRARY_PATH even when installed (no harmful effect seen though).
# 
# set(SYS_LIBDIRS "/usr/lib64" "/usr/lib64/" "/usr/lib" "/usr/lib/" "")
# set(METVIEW_LD_PATHS "")
# 
# foreach(LIBPATH ${MAGICS_LIB_DIR} ${ODB_API_LIB_DIR} ${GRIB_API_LIB_DIR})
#     list(FIND SYS_LIBDIRS ${LIBPATH} IND)
#     if(IND EQUAL -1)  # path not in the list of system paths
#         set(METVIEW_LD_PATHS "${LIBPATH}:${METVIEW_LD_PATHS}")
#     endif()
# endforeach()



# MAGPLUS_HOME - under normal circumstances, we link with a specific
# Magics library which knows where it's been installed, so we don't
# need (or want) to set MAGPLUS_HOME, and in fact we want to avoid

=== src/Desktop/CMakeLists.txt ===
set(desktop_qt_wrap_files                          
                         MvQAdvancedSearch.h
                         MvQBookmarks.h
                         MvQEditor.h
                         MvQFileBrowser.h
                         MvQDetailedFolderView.h
                         MvQIconMimeData.h
                         MvQColourGradLine.h
                         MvQColourListLine.h
                         MvQDrawerPanel.h
                         MvQPathWidget.h
                         Runnable.h
                         MvQFileWatcher.h
                         MvQFind.h
                         MvQFolderDrawerPanel.h
                         MvQFolderHistory.h
                         MvQFolderPanel.h
                         MvQFolderWidget.h
                         MvQFolderModel.h
                         MvQIconFolderView.h
                         MvQFolderViewDelegate.h
                         MvQFolderWatcher.h
                         #MvQHelpBrowser.h
                         MvQListFolderViewBase.h
                         MvQNewIconWidget.h
                         MvQRequestPanelLine.h
                         MvQBoolLine.h
                         MvQColourLine.h
                         MvQComboBoxLine.h
                         MvQIconHolder.h
                         MvQIconLine.h
                         MvQScrolledTextLine.h
                         MvQSearchPanel.h
                         MvQStringLine.h
                         MvQTextLine.h
                         MvQRequestPanelHelp.h
                         MvQColourHelp.h
                         MvQListHelp.h
                         MvQIconHelp.h
                         MvQLogDialog.h
                         MvQPageView.h
                         MvQProductBrowser.h
                         MvQRequestPanelWidget.h
                         MvQScriptHelp.h
                         MvQSliderLine.h
                         MvQStationsHelp.h
                         MvQTemplateDrawer.h
                         MvQTemporaryEditor.h
                         #MvQTools.h
                         MvQViewDrawer.h
                         ComputeEditor.h
                         ViewEditor.h
                         SimpleEditor.h
                         FamilyEditor.h
                         MacroParamEditor.h
                         Tools.h
                         Input.h
 )

if(METVIEW_QT5)
  QT5_WRAP_CPP(Desktop_MOC 
       ${desktop_qt_wrap_files}
  )
  QT5_ADD_RESOURCES(Desktop_RES desktop.qrc)
else()
  QT4_WRAP_CPP(Desktop_MOC 
       ${desktop_qt_wrap_files}
  )
  QT4_ADD_RESOURCES(Desktop_RES desktop.qrc)
endif()

set(desktop_srcs    MvMainQtBrowser.cc
                    MvQ.cc
                    MvQActionList.cc
                    MvQAdvancedSearch.cc
                    MvQBookmarks.cc
                    MvQBoolLine.cc
                    MvQColourHelp.cc
                    MvQColourLine.cc
                    MvQColourGradLine.cc
                    MvQColourListLine.cc
                    MvQComboBoxLine.cc
                    MvQContextMenu.cc
                    MvQDesktop.cc
                    MvQDesktopSettings.cc
                    MvQDetailedFolderView.cc
                    MvQDrawerPanel.cc
                    MvQDrawerView.cc
                    MvQEditor.cc
                    MvQExternalHelp.cc
                    MvQFileBrowser.cc
                    MvQFileWatcher.cc
                    MvQFind.cc
                    MvQFolderDrawerPanel.cc
                    MvQFolderHistory.cc
                    MvQFolderItemProperty.cc
                    MvQFolderModel.cc
                    MvQFolderNavigation.cc
                    MvQFolderPanel.cc
                    MvQFolderViewBase.cc
                    MvQFolderViewDelegate.cc
                    MvQFolderViewHandler.cc
                    MvQFolderWatcher.cc
                    MvQFolderWidget.cc
                    MvQGeoHelp.cc
                    #MvQHelpBrowser.cc
                    MvQIconFolderView.cc
                    MvQIconHelp.cc
                    MvQIconHelpView.cc
                    MvQIconHolder.cc
                    MvQIconLine.cc
                    MvQIconMimeData.cc
                    MvQIconObjectModel.cc
                    MvQIconProvider.cc
                    MvQIconStripView.cc
                    MvQListHelp.cc
                    MvQListFolderViewBase.cc
                    MvQLogDialog.cc
                    MvQMessageBox.cc
                    MvQNewIconWidget.cc
                    MvQNoneLine.cc
                    MvQPageView.cc
                    MvQPalette.cc
                    MvQPathWidget.cc
                    MvQProductBrowser.cc
                    MvQRecentIcons.cc
                    MvQRequestPanelHelp.cc
                    MvQRequestPanelLine.cc
                    MvQRequestPanelWidget.cc
                    MvQScriptHelp.cc
                    MvQScrolledTextLine.cc
                    MvQSearchPanel.cc
                    MvQSliderLine.cc
                    MvQStationsHelp.cc
                    MvQStringLine.cc
                    MvQTemplateDrawer.cc
                    MvQTemporaryEditor.cc
                    MvQTextLine.cc
                    MvQTheme.cc
                    #MvQTools.cc
                    MvQViewDrawer.cc
                    Action.cc
                    ActionCommand.cc
                    Command.cc
                    ComputeEditor.cc
                    ConfigLoader.cc
                    Counted.cc
                    Dependancy.cc
                    Drop.cc
                    Editor.cc 
                    EditorDrawerFactory.cc
                    EditorFactory.cc
                    EditTransaction.cc
                    FamilyEditor.cc
                    FamilyObject.cc
                    FamilyScanner.cc
                    FileObject.cc
                    Folder.cc
                    FolderDatabase.cc
                    FolderInfo.cc
                    FolderSearchData.cc
                    FolderSettings.cc
                    HelpFactory.cc
                    IconClass.cc 
                    IconFactory.cc
                    IconGroupTools.cc
                    IconInfo.cc
                    IconObject.cc
                    Input.cc
                    InternalService.cc
                    InternalTask.cc
                    Items.cc
                    Language.cc
                    LineFactory.cc
                    Log.cc
                    MacroGuiObject.cc
                    MacroObject.cc
                    MacroParamEditor.cc
                    MacroParamObject.cc
                    MacroParamState.cc
                    MessageObserver.cc
                    MethodCommand.cc
                    MetviewService.cc
                    MetviewTask.cc
                    NoEditor.cc
                    Parameter.cc
                    Product.cc
                    ProductFolder.cc
                    Protocol.cc
                    Queue.cc
                    RequestPanel.cc
                    RequestPanelItem.cc
                    ReplyObserver.cc
                    ResolveTransaction.cc
                    RootFolder.cc
                    Runnable.cc
                    ShellService.cc
                    ShellTask.cc
                    Service.cc
                    ServiceEditor.cc
                    SimpleEditor.cc
                    StandardObject.cc
                    State.cc
                    SystemFolder.cc
                    Task.cc
                    TeeBuffer.cc
                    TeeStream.cc
                    TemporaryEditor.cc
                    TemporaryFolder.cc
                    TemporaryObject.cc
                    Tools.cc
                    Transaction.cc
                    ViewEditor.cc
                    Wastebasket.cc)



ecbuild_add_executable( TARGET       Desktop
                        SOURCES      ${desktop_srcs}
                                     ${Desktop_MOC}
                                     ${Desktop_RES}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${GDBM_LIB}
                    )

=== src/Macro/CMakeLists.txt ===
# TODO: mvimportDesktop  perlaccess????


set(Macrolib_srcs
    value.cc code.cc variable.cc context.cc script.cc files.cc
    misc.cc number.cc stack.cc date.cc mstring.cc request.cc
    Unix.cc grib.cc mlist.cc module.cc remote.cc function.cc
    matrix.cc image.cc arith.cc extern.cc mvector.cc mtable.cc library.cc
    debug.cc bufr.cc compute.cc mgptset.cc vismod.cc macroy.c
    netcdf.cc object.cc pngjpeg.cc mflextra.cc python.cc
)


include_directories( include )  # relative to the current source directory


if( HAVE_PPROC_MIR )
    add_definitions( -DHAVE_PPROC_MIR )
    include_directories(${MIR_INCLUDE_DIRS})
endif()


ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/macrol.c
	COMMAND ${FLEX_EXECUTABLE} -l ${CMAKE_CURRENT_SOURCE_DIR}/macrol.l\; sed -e s/yy/zz/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/macrol.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macrol.l)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/macroy.c
	COMMAND ${BISON_EXECUTABLE} -y ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y\; sed -e s/yy/zz/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/macroy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y ${CMAKE_CURRENT_BINARY_DIR}/macrol.c)

ADD_CUSTOM_TARGET(macrolex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/macroy.c ${CMAKE_CURRENT_BINARY_DIR}/macrol.c)



#set(Macro_libs ${STANDARD_METVIEW_LIBS_ODB} ${METVIEW_EXTRA_LIBRARIES})

if(ENABLE_ODB)
    list(APPEND Macrolib_srcs codb.cc)
    list(APPEND Macro_libs ${METVIEW_ODB_API_LIBRARIES})
endif()


ecbuild_append_to_rpath("../lib") # so that libMvMacro can find libMvUtil, etc
ecbuild_add_library( TARGET           MvMacro
					 TYPE             SHARED
					 SOURCES          ${Macrolib_srcs}
					 TEMPLATES        ${common_templates}
					 DEFINITIONS      ${METVIEW_EXTRA_DEFINITIONS}
					 PRIVATE_INCLUDES ${METVIEW_STANDARD_INCLUDES}
					 LIBS             ${Macro_libs} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
					)

set(link_libs MvMacro Metview MvMars)
if (HAVE_FORTRAN)
    list(APPEND link_libs macro_api_f90)
endif()

#target_link_libraries(link_libs)


#target_link_libraries(MvMacro
#	 ${Macro_libs} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
#	"-Wl,--whole-archive"
##    app models
##    "-Wl,--no-whole-archive"
#)
# GIVES THE FOLLOWING ERROR:
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS): In function `_ZGVbN2v___log_finite':
#/home/abuild/rpmbuild/BUILD/glibc-2.22/mathvec/../sysdeps/x86_64/fpu/svml_finite_alias.S:31: multiple definition of `_ZGVbN2v___log_finite'
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS):/home/abuild/rpmbuild/BUILD/glibc-2.22/mathvec/../sysdeps/x86_64/fpu/svml_finite_alias.S:31: first defined here
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS): In function `_ZGVcN4v___log_finite':


ecbuild_add_executable( TARGET       macro
                        SOURCES      main.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${link_libs} #MvMacro
                    )

#ecbuild_add_executable( TARGET       pytest
#						SOURCES      python.cc
#						DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
#						LIBS         ${link_libs} MvMacro
#					)


ADD_DEPENDENCIES(macro macrolex)


######################################################################################

# PROBLEM getting CMake to accept the arguments to 'sed'. One possibility would be to
# put this into a separate script; another would be to simply put the beau.h file
# directly into the repository and skip the step of generating it.

#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beaul.c
#	COMMAND lex -l ${CMAKE_CURRENT_SOURCE_DIR}/beaul.l\; sed -e s/yy/zz/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/beaul.c
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/beaul.l)
#
#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beauy.c
#	COMMAND yacc -t ${CMAKE_CURRENT_SOURCE_DIR}/beauy.y\; sed -e s/yy/zz/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/beauy.c
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y)
#
#set(BS \\)
##	COMMAND sed -e 's/\\(.*\\)/\\"\\1\\",/' < ${CMAKE_CURRENT_SOURCE_DIR}/beau.ps > ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#	COMMAND sed -e 's/${BS}(.*${BS})/${BS}\"${BS}1\",/' < ${CMAKE_CURRENT_SOURCE_DIR}/beau.ps > ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/beauy.y)
#
#
#ADD_CUSTOM_TARGET(beaulex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/beauy.c ${CMAKE_CURRENT_BINARY_DIR}/beaul.c ${CMAKE_CURRENT_BINARY_DIR}/beau.h)
#
#
#ecbuild_add_executable( TARGET       beautify
#                        SOURCES      beauy.y beautify.c 
#                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
#                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR}
#                        LIBS         ${Macro_libs}
#                    )
#
#ADD_DEPENDENCIES(beautify beaulex)


######################################################################################


set(mvimport_srcs
    mvimport.c
)

ecbuild_add_executable( TARGET       mvimport
                        SOURCES      ${mvimport_srcs}
                        DEFINITIONS
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )


######################################################################################


set(mvimportDesktop_srcs
    mvimportDesktop.c
)

ecbuild_add_executable( TARGET       mvimportDesktop
                        SOURCES      ${mvimportDesktop_srcs}
                        DEFINITIONS
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

=== src/libFTimeUtil/CMakeLists.txt ===
set(libFTimeUtil_srcs
    fmettim.cc fdyntime.cc fstatime.cc fsortabl.cc fobject.cc fdyntime.h fmettim.h fobject.h fsortabl.h fstatime.h
)


ecbuild_add_library( TARGET           MvFTimeUtil
                     TYPE             SHARED
                     SOURCES          ${libFTimeUtil_srcs}
                     TEMPLATES        ${common_templates}
                     PRIVATE_INCLUDES ${METVIEW_STANDARD_INCLUDES}
                     DEFINITIONS      ${METVIEW_EXTRA_DEFINITIONS}
                     LIBS             ${METVIEW_EXTRA_LIBRARIES}
                     DEPENDS          mvmarsxdr
                    )

=== src/libMars/CMakeLists.txt ===

#### NOTE: rpcmars.h rpcmars.c should not be in the distro!!!

# the 'plain' filenames of the MARS source code
set(_libMars_srcs
    tcp.c server.c request.c expand.c
	hash.c memory.c logfile.c options.c
	api.c apibase.c base.c netbase.c netcdf.c hdf5.c nullbase.c fdb5base.cc forwardbase.c
	gribbase.c nfdbbase.c dhsbase.c odb.cc odbbase.c
	multibase.c archive.c retrieve.c ibmblk.c
	lock.c files.c sh2ll.c guess.c hypercube.c
	check.c environ.c
	handler.c target.c grib.c calc.c field.c
	list.c tools.c hidden.c index.c bufr.c
	externf.c service.c xservice.c
	udp.c queue.c variable.c
	filebase.c account.c cos.c pproc.h pproc.cc pproc_none.cc restricted.c
	wind.c control.c stream.c
	remove.c authenticate.c flatfilebase.c time.c timer.c json.c
	version.c statistics.c metadata.c ecaccess.c free.c
	schedule.c

    # add the header files because we use this list to help create the tarball later
	api.h base.h bufr.h control.h cos.h ecaccess.h field.h globals.h grib.h hypercube.h
	ibmblk.h index.h json.h lang.h mars.h mcs.h
	ncmerge.h ncschema.h nctarget.h nctypes.h netbase.h
	netbase.h odb.h proto.h queue.h restricted.h tools.h variable.h 
)


# extra files which will be needed in the tarball
set(extra_files_for_tarball
    ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
    ${MARS_SOURCE}/rpcmars.x
    ${MARS_SOURCE}/langy.y
    ${MARS_SOURCE}/langl.l
    ${MARS_SOURCE}/CMakeLists.txt            # needed for bundle tarball
    ${MARS_SOURCE}/mars_client_version.c.in  # needed for bundle tarball
    ${MARS_SOURCE}/mars_client_version.h.in  # needed for bundle tarball
    ${MARS_SOURCE}/mars_client_config.h.in   # needed for bundle tarball
)    


if( HAVE_PPROC_EMOS )
    list( APPEND _libMars_srcs pproc_emos.cc )
endif()

if( HAVE_PPROC_MIR )
    list( APPEND _libMars_srcs pproc_mir.cc )
endif()

if(HAVE_NETCDF)
  list(APPEND _libMars_srcs
    nctarget.c
    nctypes.c
    ncschema.c
    ncmerge.c
    )
endif()



# add the path to where the source files are located
foreach( file ${_libMars_srcs} )
    list( APPEND libMars_srcs ${MARS_SOURCE}/${file} )
endforeach()


ecbuild_generate_config_headers()
configure_file( ${MARS_SOURCE}/mars_client_config.h.in    mars_client_config.h   )


# get the MARS client version number (just invent it for now since we don't use it)

set(MARS_CLIENT_MAJOR_VERSION 0)
set(MARS_CLIENT_MINOR_VERSION 0)
set(MARS_CLIENT_PATCH_VERSION 0)
configure_file( ${MARS_SOURCE}/mars_client_version.h.in  mars_client_version.h )
configure_file( ${MARS_SOURCE}/mars_client_version.c.in  mars_client_version.c )



# copy all the MARS source files to a subdirectory of the build directory; this is
# so that we have a clean version of the MARS client source code in its own directory
# which can be packaged into the export tarball.
# NO - see code at the end of this file for the real solution
#foreach( file ${libMars_srcs} )
#    get_filename_component( basefile ${file} NAME )
#    configure_file(${file} "${CMAKE_BINARY_DIR}/src/libMarsClient/${basefile}" COPYONLY) # copy to binary dir
#endforeach()

# add the local and generated files - they are not in the MARS source directory
list( APPEND libMars_srcs ${CMAKE_CURRENT_BINARY_DIR}/langy.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.c)


if ( NOT FDB_FOUND )
    add_definitions(-DNOFDB)
endif()

if ( NOT HAVE_FDB5 )
    add_definitions(-DNOFDB5)
endif()

find_package(CMath)



# rpcgen, when creating the .c file, has an include for the header file;
# unfortunately, it does not know where the header file has been generated, so it
# assumes it will be in the source directory. This is wrong, it should be the
# binary directory. Therefore, we first copy the .x file to the binary directory
# and work on it there. Note: will this cause a problem with in-source builds?
# If so, we may need to first check whether the file already exists.

if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
    configure_file(${MARS_SOURCE}/rpcmars.x ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x)
endif()

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
	COMMAND rpcgen -h -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${MARS_SOURCE}/rpcmars.x)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.c
	COMMAND rpcgen -c -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${MARS_SOURCE}/rpcmars.x)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langl.c
	COMMAND lex -l ${MARS_SOURCE}/langl.l\; sed -e s/yy/yy_mars/g < lex.yy.c | egrep -v "^#line" > ${CMAKE_CURRENT_BINARY_DIR}/langl.c
    DEPENDS ${MARS_SOURCE}/langl.l)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langy.c
	COMMAND yacc -t ${MARS_SOURCE}/langy.y\; sed -e s/yy/yy_mars/g < y.tab.c | egrep -v "^#line" > ${CMAKE_CURRENT_BINARY_DIR}/langy.c
    DEPENDS ${MARS_SOURCE}/langy.y)

ADD_CUSTOM_TARGET(mvmarsxdr DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.c)
ADD_CUSTOM_TARGET(mvmarslex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/langy.c   ${CMAKE_CURRENT_BINARY_DIR}/langl.c)

###set( libMars_srcs ${libMars_srcs} PARENT_SCOPE )

include_directories(BEFORE   ${CMAKE_CURRENT_BINARY_DIR} ${METVIEW_STANDARD_INCLUDES} ${METVIEW_ODB_API_INCLUDE_DIRS})



if (ODB_API_FOUND)
    set(ODB_FLAG ODB_SUPPORT)
else()
    set(ODB_FLAG NOODB)
endif()


ecbuild_add_library( TARGET      MvMars
                     TYPE        SHARED
                     GENERATED   mars_client_version.c
                     SOURCES     ${libMars_srcs} mars_client_version.c
                     TEMPLATES   ${common_templates}
                     DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS} ${ODB_FLAG}
                     LIBS        ${MARS_FEATURE_LIBRARIES} ${METVIEW_EXTRA_LIBRARIES} ${METVIEW_ODB_API_LIBRARIES} ${CURL_LIBRARIES}
                     PRIVATE_INCLUDES
                         ${NETCDF_INCLUDE_DIRS}
                         ${MIR_INCLUDE_DIRS}
                    )

# we generate a separate MARS library which is static, hopefully making
# the inline C and Fortran easier to handle (fewer dependencies this way)
# ecbuild_add_library( TARGET      MvMarsStatic
#                      TYPE        STATIC
#                      GENERATED   mars_client_version.c
#                      SOURCES     ${libMars_srcs} mars_client_version.c
#                      TEMPLATES   ${common_templates}
#                      DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS} ${ODB_FLAG}
#                      LIBS        ${MARS_FEATURE_LIBRARIES} ${METVIEW_EXTRA_LIBRARIES} ${METVIEW_ODB_API_LIBRARIES} ${CURL_LIBRARIES}
#                      PRIVATE_INCLUDES
#                          ${NETCDF_INCLUDE_DIRS}
#                          ${MIR_INCLUDE_DIRS}
#                     )
# 
ADD_DEPENDENCIES(MvMars       mvmarsxdr mvmarslex)
# ADD_DEPENDENCIES(MvMarsStatic mvmarsxdr mvmarslex)



if(NOT DEFINED METVIEW_BUNDLE)

    # for the tarball, we want to include the MARS client source, but only the files that we actually
    # use in Metview. So we create a list of all files in the source, then subtract from it the list
    # of source files defined previously as libMars_srcs.

    # first, list all the files in the MARS source directory - these are the files we will NOT pack
    file(GLOB mars_unwanted_src_files   "${MARS_SOURCE}/*")
    file(GLOB mars_unwanted_tools_files "${MARS_SOURCE}/tools/*")
    list(APPEND mars_unwanted_src_files ${mars_unwanted_tools_files})

    # remove each wanted source file from the list
    foreach( file ${libMars_srcs} ${extra_files_for_tarball})
        list(REMOVE_ITEM mars_unwanted_src_files ${file})
    endforeach()

    # these filenames will be treated as regular expressions, so we need to be more
    # explicit and put a dollar sign at the end so that they don't match with too much
    set(mars_real_unwanted_src_files "")
    foreach( file ${mars_unwanted_src_files} )
        list(APPEND mars_real_unwanted_src_files "${file}\$")
    endforeach()

    # add our revised list to ECBUILD_DONT_PACK_FILES
    # - we don't use ecbuild_dont_pack() because it makes everything relative to the
    #   source directory
    list( APPEND ECBUILD_DONT_PACK_FILES ${mars_real_unwanted_src_files})
    set( ECBUILD_DONT_PACK_FILES ${ECBUILD_DONT_PACK_FILES} CACHE INTERNAL "" )

endif()


# soon to be redundant - remove unwanted files from libMars/MARS
# list of files (regular expressions) to exclude from the source tarball
# note "MARS/m$" - the dollar is required because otherwise CPACK will exclude any
# file beginning with an 'm'!
ecbuild_dont_pack(REGEX "MARS/config*")
ecbuild_dont_pack(REGEX "MARS/make*")
ecbuild_dont_pack(FILES "MARS/mars.test;MARS/m$;MARS/gnumake_target;MARS/Makefile;MARS/account_check.c")
ecbuild_dont_pack(FILES "MARS/blk.c;MARS/certify.c;MARS/cpli.h;MARS/cvers.h;MARS/dce.c;MARS/dce.h;MARS/dcebase.c;MARS/dceclient.c")
ecbuild_dont_pack(FILES "MARS/dceremote.c;MARS/dceserver.c;MARS/eccert.c;MARS/eccert.h;MARS/ecopt.h;MARS/emoscycle.c;MARS/extargs.c;")
ecbuild_dont_pack(FILES "MARS/feedtask.c;MARS/gpl-3.0.txt;MARS/grib_api_release.c;MARS/htest.c;MARS/lckfile.c")
ecbuild_dont_pack(FILES "MARS/licence_header;MARS/mars.c;MARS/marsdce.c;MARS/marsdce.h;MARS/marsfdb.c;MARS/marsmon.c;MARS/marsversion.c")
ecbuild_dont_pack(FILES "MARS/mcs.c;MARS/mrpc.x;MARS/msbase.c;MARS/multidef.c;MARS/multidef.h;MARS/ocean.c")
ecbuild_dont_pack(FILES "MARS/rdb.c;MARS/reqmerge.c;MARS/source.c;MARS/source.h;MARS/test.c;MARS/testh.c;MARS/teststats.c")

=== src/libMarsClient/CMakeLists.txt ===
### config headers

configure_file( mars_client_version.h.in  mars_client_version.h )
configure_file( mars_client_version.c.in  mars_client_version.c )

# compile definitions

ecbuild_generate_config_headers()
configure_file( mars_client_config.h.in    mars_client_config.h   )

add_definitions( -DR64 )

if( ECMWF )
    add_definitions( -DECMWF )
endif()

# ecbuild automatically test endiness and sets variable EC_BIG_ENDIAN or EC_LITTLE_ENDIAN
if( EC_BIG_ENDIAN )
	message( STATUS "System is big endian" )
else()
	message( STATUS "System is little endian" )
	add_definitions(-DLITTLE_END)
endif()

if( NOT HAVE_FDB )
    add_definitions(-DNOFDB)
endif()

if( NOT HAVE_FDB5 )
    add_definitions(-DNOFDB5)
endif()

if( NOT HAVE_ODB )
	add_definitions(-DNOODB)
else()
	add_definitions(-DODB_SUPPORT )
	include_directories( ${ODB_API_INCLUDE_DIRS} ${ECKIT_INCLUDE_DIRS} )
endif()

if( HAVE_ODBDIRECT )
  add_definitions(-DODBDIRECT)
  include_directories( ${MARS_SERVER_INCLUDE_DIRS} ${ODB_API_INCLUDE_DIRS} ${ECKIT_INCLUDE_DIRS} )
endif()

if( HAVE_PPROC_EMOS )
    list( APPEND mars_client_src_files pproc_emos.cc )
endif()

if( HAVE_PPROC_MIR )
    list( APPEND mars_client_src_files pproc_mir.cc )
endif()

if( NOT CURL_FOUND )
	add_definitions(-DNOCURL)
endif()

if(HAVE_ECMWF_DEVELOPMENT)
  add_definitions(-DECMWF)
  add_definitions(-DNOEMS)
  add_definitions(-DNOAUTH)
  add_definitions(-DNOSCHEDULE)
endif()

# sources

list( APPEND mars_client_src_files
account.c
archive.c
authenticate.c
base.c
bufr.c
calc.c
certify.c
check.c
control.c
cos.c
ecaccess.c
eccert.c
environ.c
expand.c
extargs.c
externf.c
fdb5base.cc
forwardbase.c
odbdirect.cc
feedtask.c
field.c
filebase.c
files.c
flatfilebase.c
free.c
gribbase.c
grib.c
guess.c
handler.c
hash.c
hidden.c
hypercube.c
ibmblk.c
index.c
langy.c
list.c
lock.c
logfile.c
marsxdr.c
mcs.c
memory.c
dhsbase.c
metadata.c
msbase.c
multibase.c
netbase.c
netcdf.c
hdf5.c
nfdbbase.c
nullbase.c
odbbase.c
options.c
pproc.h
pproc.cc
pproc_none.cc
queue.c
rdb.c
remove.c
request.c
restricted.c
retrieve.c
schedule.c
server.c
service.c
sh2ll.c
statistics.c
stream.c
target.c
tcp.c
time.c
timer.c
tools.c
udp.c
variable.c
version.c
json.c
odb.cc
api.c
apibase.c
wind.c)

if(HAVE_UDP_STATS)
  list(APPEND mars_client_src_files udp_statistics.cc)
  list(APPEND eckit_libs            eckit )
endif()

if(HAVE_NETCDF)

  list(APPEND mars_client_src_files
    nctarget.c
    nctypes.c
    ncschema.c
    ncmerge.c
    )

endif()

# targets

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rpcmars.x ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x COPYONLY )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
	COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
	COMMAND rpcgen -h -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
	COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
	COMMAND rpcgen -c -o ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langl.c
	COMMAND lex -l ${CMAKE_CURRENT_SOURCE_DIR}/langl.l\; sed -e s/yy/yy_mars/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/langl.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langl.l)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langy.c
	COMMAND yacc -t ${CMAKE_CURRENT_SOURCE_DIR}/langy.y\; sed -e s/yy/yy_mars/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/langy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langy.y)

add_custom_target(marsxdr DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c)
add_custom_target(marslex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/langy.c ${CMAKE_CURRENT_BINARY_DIR}/langl.c)


set( grib_handling_pkg eccodes )

ecbuild_add_library(
    TARGET      marsclient
    GENERATED   mars_client_version.c
	SOURCES     ${mars_client_src_files} mars_client_version.c
	DEPENDS     marsxdr marslex
    PRIVATE_INCLUDES
        ${NETCDF_INCLUDE_DIRS}
        ${ECKIT_INCLUDE_DIRS}
        ${MARS_SERVER_INCLUDE_DIRS}
        ${GRIB_API_INCLUDE_DIRS}
        ${MIR_INCLUDE_DIRS}
        ${CURL_INCLUDE_DIRS}
    DEFINITIONS
        ${GRIB_API_DEFINITIONS}
    LIBS
        ${grib_handling_pkg}
        ${MARS_FEATURE_LIBRARIES}
        ${eckit_libs}
        ${CURL_LIBRARIES}
        ${CMATH_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
)

set_directory_properties( ADDITIONAL_MAKE_CLEAN_FILES rpcmars.h marsxdr.c langl.c langy.c )

ecbuild_add_executable(
    TARGET    mars.bin
    INCLUDES  ${MIR_INCLUDE_DIRS} ${LIBEMOS_INCLUDE_DIRS} ${GRIB_API_INCLUDE_DIRS}
    SOURCES   mars.c
    LIBS      marsclient
)

ecbuild_add_executable(
    TARGET    test-udp-stats
    SOURCES   test-udp-stats.c
    CONDITION HAVE_UDP_STATS
    LIBS      marsclient
)

add_subdirectory( tools )

=== src/libMetview/CMakeLists.txt ===
set(libMetview_srcs
      MvService.cc 
      MvProtocol.cc
      MvFunction.cc
      MvApplication.cc
      MvRequest.cc
      MvLanguage.cc
      MvGeoPoints.cc
      MvGeoPointSet.cc
      MvGrid.cc
      MvFieldSet.cc
      MvFilter.cc
      MvFlextra.cc
      MvFlexpart.cc
      MvSerie.cc
      MvTable.cc
      MvFortran.cc
      MvDate.cc
      MvTimeSerie.cc
      MvLocation.cc
      MvObsSet.cc
      MvObs.cc
      MvObsUtil.cc
      MvPrepBufrPrep.cc
      MvTask.cc
      MvServiceTask.cc
      MvShellTask.cc
      MvVisTool.cc
      LLMatrixToGRIB.cc
      MvMatrix.cc
      MvScanFileType.cc
      MvDebugPrintControl.cc
      Path.cc
      Box.cc
      BufrFilterDef.cc
      BufrFilterEngine.cc
      BufrLocationCollector.cc
      Cached.cc
      GribMetaData.cc
      LogHandler.cc
      MtInputEvent.cc
      MvAlmostObsoleteRequest.cc
      MvBinaryReader.cc
      MvBufrEdition.cc
      MvBufrElementTable.cc
      MvEccBufr.cc
      MvElement.cc
      MvException.cc
      MvKeyCondition.cc
      MvKeyProfile.cc
      MvKeyManager.cc
      MvList.cc
      MvMessageMetaData.cc
      MvMiscelaneous.cc
      MvPath.cc
      MvProfileData.cc
      MvRequestUtil.cc
      MvRttov.cc
      MvScm.cc
      MvStopWatch.cc
      MvTmpFile.cc
      MvVariant.cc
      MvVersionInfo.cc
      Point.cc
      proj_braz.cc
      Request.cc
      TableReader.cc
      Tokenizer.cc
      UtilitiesC.c
      MvNetCDF.cc)

if (ENABLE_URL_DOWNLOAD)
    list (APPEND libMetview_srcs MvNetwork.cc)
endif()


if (ODB_API_FOUND)
    list(APPEND libMetview_srcs MvOdb.cc)
endif()


ecbuild_add_library( TARGET           Metview
                     TYPE             SHARED
                     SOURCES          ${libMetview_srcs}
                     TEMPLATES        ${common_templates}
                     PRIVATE_INCLUDES ${METVIEW_STANDARD_INCLUDES}
                     DEFINITIONS      ${METVIEW_EXTRA_DEFINITIONS}
                     LIBS             ${METVIEW_EXTRA_LIBRARIES}
                     DEPENDS          mvmarsxdr MvMars MvFTimeUtil
                    )


target_link_libraries(Metview MvMars MvFTimeUtil)  # 'a' depends on 'b' and 'c'


ecbuild_dont_pack(FILES "Demo.cc;DemoFort.cc;Doxyfile;SampleModule.cc;SampleObs.cc;demofort.f")

=== src/libMvQtUtil/CMakeLists.txt ===

set(header_files_for_moc MvQFileList.h MvQNetworkAccessManager.h MvQNetworkAccessManager.h )

if(METVIEW_QT5)
  QT5_WRAP_CPP(MvQtUtil_MOC ${header_files_for_moc})
else()
  QT4_WRAP_CPP(MvQtUtil_MOC ${header_files_for_moc})
endif()


set(libMvQtUtil_srcs
    MvQFileInfo.cc
    MvQFileList.cc
    MvQFileUtil.cc
    MvQKeyManager.cc
    MvQNetworkAccessManager.cc
    MvQNetworkProxyFactory.cc
    MvQObstatScatterData.cc
    MvQProperty.cc
    MvQVisDefManager.cc
    MvQXmlQuery.cc
)

set(libmvqtutil_includes ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES})

if (METVIEW_ODB)
    list(APPEND libMvQtUtil_srcs MvQOdbMetaData.cc MvQOdbMetaData.h)
    list(APPEND libmvqtutil_includes ${METVIEW_ODB_API_INCLUDE_DIRS})
endif()



ecbuild_add_library( TARGET      MvQtUtil
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libMvQtUtil_srcs} ${generated_srcs} ${MvQtUtil_MOC}
                     TEMPLATES   ${common_templates}
                     INCLUDES    ${libmvqtutil_includes}
                     DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS}
                     DEPENDS     mvmarsxdr
)

=== src/uPlot/CMakeLists.txt ===
set(common_srcs
    AnnotationView.cc AverageView.cc BufrDecoder.cc
    Canvas.cc CartesianView.cc CommonXSectView.cc
    CreateAction.cc CreateTypeAction.cc
    DataBuilder.cc DataObject.cc Device.cc
    DrawingPriority.cc DropAction.cc
    GenAppService.cc
    GeopointsDecoder.cc GraphicsEngine.cc MvGribDecoder.cc
    HovmoellerView.cc Location.cc
    MvLayer.cc MacroConverter.cc MacroVisitor.cc
    MagicsGraphicsEngine.cc MagicsTranslator.cc
    MagPlusService.cc MapView.cc MatchingCriteria.cc MatchingInfo.cc
    MvDecoder.cc MvIcon.cc MvIconDataBase.cc
    NewpageAction.cc
    ObjectInfo.cc ObjectList.cc OutputFormatAction.cc
    Page.cc PlotAction.cc PlotMod.cc PlotModAction.cc PlotModBuilder.cc
    PlotModService.cc PlotModTask.cc PlotModView.cc PlotPageBuilder.cc
    PmContext.cc PmIndividualProjection.cc PmGeneralProjection.cc PmProjection.cc
    Preferences.cc Presentable.cc
    Root.cc
    SatelliteProjection.cc ShareTargets.cc SimpleDecoder.cc
    SkipAction.cc SubPage.cc SuperPage.cc
    Task.cc ThermoView.cc VertProfView.cc XDevice.cc XSectView.cc ZoomStacks.cc)

if(ENABLE_UI)


set(common_qt_srcs
    MvQCursorData.cc
    MvQCursorDataWidget.cc
    MvQContentsModel.cc
    MvQContentsWidget.cc
    MvQDataWidget.cc
    MvQLayerContentsIcon.cc
    MvQLayerDataWidget.cc
    MvQLayerMetaDataWidget.cc
    MvQLayerModel.cc
    MvQLayerSuperPage.cc
    MvQLayerViewLevel.cc
    MvQLayerWidget.cc
    MvQMagnifier.cc
    MvQPlaceMark.cc
    MvQPlaceMarkDialog.cc
    MvQPlaceMarkMimeData.cc
    MvQPlaceMarkWidget.cc
    MvQPlaceMarkModel.cc
    MvQPlotView.cc 
    MvQPointSelection.cc 
    MvQProgressItem.cc
    MvQStepModel.cc
    MvQStepWidget.cc
    MvQZoom.cc
    MvQAreaSelection.cc
    MvQLineSelection.cc
    MvQZoomStackWidget.cc)


set(common_moc_files 
    MvQCursorData.h
    MvQCursorDataWidget.h
    #MvQContentsModel.h
    MvQContentsWidget.h
    MvQDataWidget.h
    MvQEcChartsDialog.h
    MvQLayerContentsIcon.h
    MvQLayerDataWidget.h
    MvQLayerMetaDataWidget.h
    MvQLayerModel.h
    MvQLayerSuperPage.h
    MvQLayerViewLevel.h
    MvQLayerWidget.h
    MvQMagnifier.h
    MvQPlaceMark.h
    MvQPlaceMarkDialog.h
    MvQPlaceMarkMimeData.h
    MvQPlaceMarkWidget.h
    MvQPlaceMarkModel.h
    MvQPlotView.h 
    MvQPointSelection.h 
    #MvQProgressItem.h
    MvQStepModel.h
    MvQStepWidget.h
    MvQZoom.h
    MvQAreaSelection.h
    MvQLineSelection.h
    MvQZoomStackWidget.h
    ExportDialog.h
    uPlotBase.h
    uPlot.h
)


set(common_ui_srcs
    MagPlusInteractiveService.cc
    PlotModInteractive.cc
    ExportDialog.cc
    MvQEcChartsDialog.cc
    uPlotBase.cc
)


# The Qt MOC file needs to be generated with the Weather Room slot functions,
# so we need to add the define here
if(ENABLE_WEATHER_ROOM)
    set(WEATHER_ROOM_MOC_FLAGS -DMETVIEW_WEATHER_ROOM)
endif()

if(METVIEW_QT5)
  QT5_WRAP_CPP(common_MOC ${common_moc_files} OPTIONS ${WEATHER_ROOM_MOC_FLAGS})
  QT5_ADD_RESOURCES(common_RES uPlot.qrc)
else()
  QT4_WRAP_CPP(common_MOC ${common_moc_files} OPTIONS ${WEATHER_ROOM_MOC_FLAGS})
  QT4_ADD_RESOURCES(common_RES uPlot.qrc)
endif()



#-------- uPLOT ------------------------------------------------------------------

set(uPlot_srcs
    MvMain.cc
    ${common_srcs}
    ${common_MOC}
    ${common_RES}
    ${common_ui_srcs}
    ${common_qt_srcs}
    uPlot.cc uPlotApp.cc
#   uPlot.h uPlotApp.h
)


if(ENABLE_WEATHER_ROOM)
    if(METVIEW_QT5)
      QT5_WRAP_CPP(wr_MOC MvQWeatherRoomDialog.h)
    else()
      QT4_WRAP_CPP(wr_MOC MvQWeatherRoomDialog.h)
    endif()
    list(APPEND uPlot_srcs  MvQWeatherRoomDialog.cc ${wr_MOC})
    set(WEATHER_ROOM_FLAGS METVIEW_WEATHER_ROOM)
endif()

if(ENABLE_SHARE_PLOT)
#    list(APPEND uPlot_srcs ShareTargets.cc)
    set(SHARE_PLOT_FLAGS METVIEW_SHARE_PLOT)
endif()

if(ENABLE_SHARE_TO_GLOBE)
     set(SHARE_GLOBE_FLAGS "MV_SHARE_GLOBE_BUILD=1")
endif()

# we need to make sure that 
#set(CMAKE_INCLUDE_DIRECTORIES_BEFORE "ON")

#include_directories(BEFORE ${MAGICS_INCLUDE_DIRS})


# the ODB_API libararies are required in the case where Metview was built with ODB support,
# but Magics wasn't

ecbuild_add_executable( TARGET       uPlot
                        SOURCES      ${uPlot_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS} ${MAGICS_DEFINITIONS} ${WEATHER_ROOM_FLAGS} ${SHARE_PLOT_FLAGS} ${SHARE_GLOBE_FLAGS}
#                        INCLUDES     /a /b /c
                        INCLUDES     ${MAGICS_INCLUDE_DIRS} ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS_ODB} MagPlus MagWrapper ${METVIEW_ODB_API_LIBRARIES}
                    )

ecbuild_debug("UPLOT CMAKE_INCLUDE_PATH: " ${CMAKE_INCLUDE_PATH})
###nodist_bin_uPlot_SOURCES = ${uPlot_COMMON_QT_SOURCES_nodist} ${uPlot_COMMON_UI_SOURCES_nodist} \
###                           uPlot.moc.cpp


endif()  # UI



set(uPlotManager_srcs
    uPlotManager.cc
    uPlotService.cc
    )
#uPlotManager.hpp uPlotService.hpp

ecbuild_add_executable( TARGET       uPlotManager
                        SOURCES      ${uPlotManager_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )


#-------- uPLOT Batch-----------------------------------------------------------------

set(uPlotBatch_srcs
    MvMainuPlotBatch.cc
    MagPlusBatchService.cc
    PlotModBatch.cc
    uPlotBatchApp.cc
    
    ${common_srcs}
)
 ###MagPlusBatchService.h PlotModBatch.h uPlotBatchApp.h

# we add the QT flags tothe compilation directives here because although this module should have
# no dependencies on Qt, it still uses Magics++, and if that has been built with Qt support, then
# we will need the flags in order to have a correct compilation. If Magics++ has been built without
# Qt, then these flags should be empty, so no harm done.

# the ODB_API libararies are required in the case where Metview was built with ODB support,
# but Magics wasn't

ecbuild_add_executable( TARGET       uPlotBatch
                        SOURCES      ${uPlotBatch_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS} ${MAGICS_DEFINITIONS}  NOMETVIEW_QT
                        INCLUDES     ${MAGICS_INCLUDE_DIRS}  ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS_ODB} MagPlus MagWrapper ${METVIEW_ODB_API_LIBRARIES}
                    )

#-------- GeoTool ---------------------------------------------------------------

if(ENABLE_UI)

if(METVIEW_QT5)
  QT5_WRAP_CPP(geotool_MOC GeoTool.h)
  QT5_ADD_RESOURCES(geotool_RES geoSelect.qrc)
else()
  QT4_WRAP_CPP(geotool_MOC GeoTool.h)
  QT4_ADD_RESOURCES(geotool_RES geoSelect.qrc)
endif()


set(uPlotGeoTool_srcs
    MvMainGeoTool.cc
    GeoTool.cc
    ${common_srcs}
    ${common_MOC}
    ${geotool_MOC}
    ${common_RES}
    ${geotool_RES}
    ${common_ui_srcs}
    ${common_qt_srcs}
    uPlot.cc uPlotApp.cc
    uPlot.h uPlotApp.h
)


# the ODB_API libararies are required in the case where Metview was built with ODB support,
# but Magics wasn't

ecbuild_add_executable( TARGET       GeoTool
                        SOURCES      ${uPlotGeoTool_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS} ${MAGICS_DEFINITIONS}
                        INCLUDES     ${MAGICS_INCLUDE_DIRS}  ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS_ODB} MagPlus MagWrapper ${METVIEW_ODB_API_LIBRARIES}
                    )

set(GeoToolManager_srcs
    GeoToolManager.cc
    )
#GeoToolManager.h

ecbuild_add_executable( TARGET       GeoToolManager
                        SOURCES      ${GeoToolManager_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )
endif()  # UI


# -------------------------------------------------------

metview_module_files(ETC_FILES ObjectSpec.OutputFormats)


ecbuild_dont_pack(FILES "MvQWeatherRoomDialog.cc;MvQWeatherRoomDialog.h" )

=== test/macros/CMakeLists.txt ===

# ------------------------------------------------------------------------
# MACRO metview_etc_files
# Ensures the files listed in ETC_FILES are copied to the build directory
# and that they will be installed at install time
# ------------------------------------------------------------------------


set (POST_INSTALL_TEST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh)
set (MVRUN "${CMAKE_INSTALL_PREFIX}/bin/${METVIEW_SCRIPT}")


macro(metview_macro_test)
    set(options)
    set(single_value_args MACRO)
    set(multi_value_args RESOURCES MACRO_ARGS)
    cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}" ${_FIRST_ARG} ${ARGN} )


    ecbuild_add_test(TARGET      ${_PAR_MACRO}_dummy_target
                     COMMAND     ${FULL_STARTUP_SCRIPT_PATH}
                     TYPE        SCRIPT
                     ARGS        -b ${_PAR_MACRO} ${_PAR_MACRO_ARGS}
                     RESOURCES   ${_PAR_MACRO} ${_PAR_RESOURCES})


    # add to the post-install tests too
    string (REPLACE ";" " " MACRO_ARGS "${_PAR_MACRO_ARGS}")  # ';' -> ' '
    file(APPEND ${POST_INSTALL_TEST_SCRIPT} "${MVRUN} -b ${_PAR_MACRO} ${MACRO_ARGS}\n")

    set(all_tests "${all_tests}${_PAR_MACRO} ") # note the spacing
endmacro()



# write the start of the post-install test script
file(WRITE  ${POST_INSTALL_TEST_SCRIPT} "#!/bin/sh\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# Run the tests on the installed version of Metview\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# -------------------------------------------------\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "set -eax\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")



set(all_tests) # empty to start with



if(ENABLE_PLOTTING)
    metview_macro_test(MACRO     HelloWorld.mv
                       RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO     layoutx3.mv
                       RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO     plot_from_read_grib.mv
                       RESOURCES set_output.mv ../data/fc_data.grib)
endif()


metview_macro_test(MACRO     grib_dates.mv
                   RESOURCES  ../data/fc_data.grib
                              ../data/hindcast.grib
                              ../data/fc_long_step.grib
                              ../data/monthly_avg.grib)

metview_macro_test(MACRO     grib_keys.mv
                   RESOURCES  ../data/fc_data.grib)

metview_macro_test(MACRO     grib_nearest_gridpoint.mv
                   RESOURCES  ../data/t1000_LL_1x1.grb
                              ../data/t1000_LL_1x1_subarea.grb
                              ../data/t1000_LL_2x2.grb
                              ../data/t1000_LL_2x2_with_missing.grb
                              ../data/t1000_reg_gg_N48.grib
                              ../data/t1000_red_gg_N48.grib)

metview_macro_test(MACRO     interpolation_sh_to_ll.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_sh_to_rgg.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_rgg_to_ll.mv
                   RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)

metview_macro_test(MACRO     grib_to_gpt.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb)

metview_macro_test(MACRO     gpt_to_grib_core.mv
                   RESOURCES  ../data/gpt_to_grib_input_1.gpt
                              ../data/gpt_to_grib_reciprocal_reference.grb
                              ../data/gpt_to_grib_exp_mean_reference.grb
                              ../data/gpt_to_grib_exp_sum_reference.grb)

metview_macro_test(MACRO     gpt_to_grib_with_template.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb ../data/10U_GG.grb)

metview_macro_test(MACRO     gpt_to_grib_nearest.mv
                   RESOURCES  ../data/t1000_LL_7x7.grb
                              ../data/example_XYLDTZ.geo
                              ../data/gpt_to_grib_nearest_sum_reference.grb
                              ../data/gpt_to_grib_nearest_mean_reference.grb
                              ../data/gpt_to_grib_nearest_count_reference.grb
                              ../data/nearest_gridpoint_gpt_ref_1.gpt)

metview_macro_test(MACRO     geopoint_types.mv
                   RESOURCES  ../data/bufr_obs_filter_basic_reference.gpt
                              ../data/example_POLAR_VECTOR.geo
                              ../data/example_XYZ.geo
                              ../data/example_XY_VECTOR.geo)

metview_macro_test(MACRO     gpt_set.mv
                   RESOURCES  ../data/gpt_to_grib_input_1.gpt
                              ../data/bufr_picker_reference.gpt
                              ../data/bufr_obs_filter_area_reference.gpt
                              ../data/bufr_obs_filter_custom_reference.gpt
                              ../data/nearest_gridpoint_gpt_ref_1.gpt
                              ../data/t1000_LL_1x1.grb
                              ../data/hindcast.grib)

#metview_macro_test(MACRO     interpolation_gg_to_subarea.mv
#                   RESOURCES  ../data/10U_GG.grb)

metview_macro_test(MACRO     bufr_obs_filter.mv
                   RESOURCES  ../data/bufr-3.bufr
				           ../data/compress_3.bufr
				           ../data/bufr_obs_filter_basic_reference.gpt
							  ../data/temp_10.bufr
							  ../data/bufr_obs_filter_level_reference.gpt
							  ../data/synop_multi_subset_uncompressed.bufr
							  ../data/bufr_obs_filter_area_reference.gpt
							  ../data/amsua_13.bufr
							  ../data/bufr_obs_filter_time_reference.gpt
							  ../data/bufr_obs_filter_custom_reference.gpt
							  ../data/bufr_obs_filter_blockstation_reference.gpt
							  ../data/aircraft_10.bufr
							  ../data/bufr_obs_filter_subtype_reference.gpt)

metview_macro_test(MACRO     bufr_picker.mv
                   RESOURCES  ../data/bufr-2.bufr ../data/bufr_picker_reference.gpt)

if(ENABLE_UI)
metview_macro_test(MACRO     bufr_filter.mv
                   RESOURCES  ../data/temp_small.bufr ../data/aircraft_small.bufr
                            ../data/synop_multi_subset_uncompressed.bufr
                            ../data/tropical_cyclone.bufr)
endif()

metview_macro_test(MACRO     inline_c.mv
                   RESOURCES ../data/z500.grb)

if(HAVE_FORTRAN)
metview_macro_test(MACRO     inline_fortran.mv
                   RESOURCES ../data/z500.grb)
endif()

metview_macro_test(MACRO     station.mv)

metview_macro_test(MACRO     vectors.mv
                   RESOURCES ../data/gpt_to_grib_nearest_sum_reference.grb
                             ../data/bufr_picker_reference.gpt)

metview_macro_test(MACRO     lists.mv)

metview_macro_test(MACRO     strings.mv)

metview_macro_test(MACRO     dates.mv)

metview_macro_test(MACRO     fieldsets.mv
                   RESOURCES ../data/hindcast.grib)

metview_macro_test(MACRO     llmatrix.mv
                   RESOURCES ../data/myllmat.llmat)


metview_macro_test(MACRO     geopoints.mv
                   RESOURCES ../data/geopoints_with_metadata.gpt
                             ../data/bufr_picker_reference.gpt)

metview_macro_test(MACRO     netcdf_computations.mv
                   RESOURCES ../data/xs_with_missing_vals.nc
                             ../data/xs_without_missing_vals.nc
                             ../data/nc_from_grib.nc
                             ../data/xs_date_mv5.nc)

#metview_macro_test(MACRO     "../../bin/mv_flextra_prep.mv 1 mv_flextra_prepare_test01.txt"
#                   RESOURCES  ../data/mv_flextra_prepare_test01.txt
#                              ../data/hindcast.grib)

metview_macro_test(MACRO     divrot.mv
                   RESOURCES ../data/vorticity_divergence_500_sh.grb)

#metview_macro_test(MACRO      mv_flextra_prep.mv
#                   MACRO_ARGS 1 mv_flextra_prepare_test01.txt
#                   RESOURCES  ../../scripts/mv_flextra_prep.mv
#                              ../data/mv_flextra_prepare_test01.txt)

if(ENABLE_MARS)
    metview_macro_test(MACRO      MarsAccess.mv
                       RESOURCES  ../data/10U_GG.grb )
endif()


if(METVIEW_ODB)
    metview_macro_test(MACRO      odb_read.mv
                       RESOURCES  ../data/odb_test_set.odb )

    metview_macro_test(MACRO      odb_filter.mv
                       RESOURCES  ../data/odb_test_set.odb )

    if(ENABLE_PLOTTING)
        metview_macro_test(MACRO      odb_visualiser.mv
                           RESOURCES  ../data/odb_test_set.odb )
    endif()
endif()


# finish the post-install test script
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# if we got this far, then all tests must have succeeded\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "echo \"ALL TESTS PASSED\"\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "echo \"\"\n")



# generate a script which can be used to run the tests on the installed version
set(METVIEW_COMMAND "${CMAKE_INSTALL_PREFIX}/bin/${METVIEW_SCRIPT}")
set(TESTS_DIR       "${CMAKE_CURRENT_BINARY_DIR}")

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh 
         DESTINATION ${MV_BIN_DIR}
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

=== share/metview/app-defaults/CMakeLists.txt ===

#### TODO
########  dirstocopy              = CommonMacroFuncs Drawers Templates news
########Drawers/Basic/Folder:
########	mkdir -p Drawers/Basic/Folder
########
########BUILT_SOURCES = Drawers/Basic/Folder




set(files
    DemoFonts Metview NormalFonts User_Dir_Frame.tar.gz Sample_Drawers.tar.gz metview.qss
    BufrKeyProfile_default.xml BufrKeyProfile_all.xml GribKeyProfile_default.xml
    FrameKeyProfile_default.xml FrameKeyProfile_all.xml LayerKeyProfile_default.xml
    Desktop.qss UiTheme.Desktop UiTheme.MacroEditor BufrFilterDef.json world_map_low.svg
)



# set up the version file


execute_process(COMMAND           date +%Y
                OUTPUT_VARIABLE   THIS_YEAR
                OUTPUT_STRIP_TRAILING_WHITESPACE)

execute_process(COMMAND           date +%d-%B-%Y
                OUTPUT_VARIABLE   THIS_VERBOSE_DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)

configure_file(MvVersion.in         ${CMAKE_BINARY_DIR}/share/metview/app-defaults/MvVersion @ONLY)
configure_file(MvVersionDetails.in  ${CMAKE_BINARY_DIR}/share/metview/app-defaults/MvVersionDetails @ONLY)


foreach( f ${files} )

    # copy to the build 'bin' directory
    configure_file(${f} ${CMAKE_BINARY_DIR}/share/metview/app-defaults/ COPYONLY)

endforeach()


foreach( f ${files} MvVersion MvVersionDetails)

    # ensure file is installed at install time
    install( FILES ${CMAKE_BINARY_DIR}/share/metview/app-defaults/${f}
             DESTINATION share/metview/app-defaults
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

endforeach()



# handle the directories which we just want to copy completely
# for efficiency, we will just create symbolic links to them (this will
# probably not work on Windows; if we want a Windows build, we'll
# need to perform an actual copy)


set(dirs CommonMacroFuncs Drawers Templates)

foreach( dir ${dirs})

    execute_process(COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_BINARY_DIR}/share/metview/app-defaults/${dir})

    execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/${dir}
                                                               ${CMAKE_BINARY_DIR}/share/metview/app-defaults/${dir}
                    RESULT_VARIABLE res
                    OUTPUT_VARIABLE outv
                    ERROR_VARIABLE  errv)
    if(NOT res EQUAL 0)
        ecbuild_critical("Could not create symbolic link to ${dir} : ${res} ${outv} , ${errv}")
    endif()


    install( DIRECTORY   ${dir}
             DESTINATION share/metview/app-defaults
             PATTERN .metview_empty_file EXCLUDE) # don't install the dummy file in Drawers/Basic/Folder

endforeach()

=== share/metview/etc/CMakeLists.txt ===

set(files
	AnnotationViewDef AnnotationViewRules
	AuxPrepBufrTable_B.txt AuxPrepBufrTable_D.txt
	AxisDef AxisRules
	BinningObjectDef BinningObjectRules
	CartesianViewDef CartesianViewRules
	CleanFileDef
	Coastlines
	CoastDef
	CoastRules
	ConfigRules
	ContDef
	ContRules
	DeviceDriverDef
	DeviceDriverRules
	DivrotDef
	DivrotRules
	DrawingPriorityDef
	DrawingPriorityRules
	EcfsDef
	EPSOutputDef
	GenAppDef
	GenAppRules
	GeoToGribDef
	GeoToGribRules
	GeoViewDef GeoViewRules
	GLOBEOutputDef
	GraphDef
	GraphRules
	GribToGeoDef
	Input_Window
	KMLOutputDef
	MARS_none
	MARS_local
	MARS_remote
	MARS_webapi
	MAXISDef MAXISRules
    MBOXPLOTDef MBOXPLOTRules
	MCOASTDef MCOASTRules
	MCONTDef MCONTRules
	MGRAPHDef MGRAPHRules
	MLEGENDDef MLEGENDRules
	MIMPORTDef MIMPORTRules  
	MSYMBDef MSYMBRules
	MTAYLORDef MTAYLORRules
	MTEXTDef MTEXTRules
	MWINDDef MWINDRules
	MacroDef
	MacroParamDef
	MacroParamRules
	MacroRules
	MagicsColours.txt
	MapViewDef
	MapViewRules
	MarsDef
	MarsRules
	ObjectList
	ObjectList.forTesting
	ObsFilterDef
	ObsFilterRules
	ObsPlottingDef
	ObsPlottingRules
	OverlayControl
	OverlayControlDef
	OverlayControlRules
	PageFrameDef
	PageFrameRules
	PDFOutputDef
	PlotPageDef
	PlotPageRules
	PlotSubPageDef
	PlotSubPageRules
	PlotSuperPageDef
	PlotSuperPageRules
	Plot_Window_for_Image
	PNGOutputDef
	PSOutputDef
	RelHumDef
	RelHumRules
	Services
	SimpleFormulaDef
	SimpleFormulaRules
	StationDef
	StationRules
	SubpageFrameDef
	SubpageFrameRules
	SVGOutputDef
	SymbDef SymbRules
	TableCommonDef TableReaderDef TableReaderRules
	TextDef TextRules
	UiSpec.Bookmarks
	UiSpec.Breadcrumbs
	UiSpec.DetailedFolderView
	UiSpec.DrawerView
	UiSpec.FolderDrawerPanel
 	UiSpec.FolderHistory
	UiSpec.FolderPanel
	UiSpec.FolderView
 	UiSpec.IconFolderView
 	UiSpec.IconHelpView 
	UiSpec.IconHolderView
 	UiSpec.TemplateDrawerView
	UiSpec.ViewDrawerView
	VelstrDef VelstrRules
	VoidDef
	WidgetDef
	WindDef
	WindRules
	dwd.def
	ecmwf.def
	italy.def
	mars.chk
	oldrd.chk
	obsgroups.def
	rt_by_obsgroup.chk
	reportypes.def
	tigge.def
    marsdb.webapi.cfg
	ms_mars.cfg
	ms_mars.cfg.INFO
	macro_deprecated_functions.txt
	macro_templates.txt
	uPlotTable
	licence_for_about_box.txt
	licence_for_macros.txt
)

set(tables
    grib_def
)

# Set the list of things that really need to be built before we can start running
# Metview for the purpose of generating Macro dictionaries, etc.

set(metview_core_targets
    event
    macro
    ObjectListAllTarget
)


set(extra_install_files macro_built_in_functions)

ADD_CUSTOM_COMMAND(
    OUTPUT  ${CMAKE_BINARY_DIR}/share/metview/etc/macro_built_in_functions.txt
    COMMAND ${FULL_STARTUP_SCRIPT_PATH} -b ${CMAKE_CURRENT_SOURCE_DIR}/../../../scripts/generate_list_of_macro_functions.mv ${CMAKE_BINARY_DIR}/share/metview/etc/macro_built_in_functions.txt
    DEPENDS ${FULL_STARTUP_SCRIPT_PATH} ${metview_core_targets}
)

#ADD_CUSTOM_TARGET(macro_built_in_functions ALL DEPENDS ${CMAKE_BINARY_DIR}/share/metview/etc/macro_built_in_functions.txt)

set (dict_file "${CMAKE_BINARY_DIR}/share/metview/etc/dict.txt")

ADD_CUSTOM_COMMAND(
    OUTPUT  ${dict_file}
    COMMAND ${FULL_STARTUP_SCRIPT_PATH} -b ${CMAKE_CURRENT_SOURCE_DIR}/../../../scripts/generate_dictionary.mv ${dict_file}
    DEPENDS ${FULL_STARTUP_SCRIPT_PATH} ${metview_core_targets}
)

#ADD_CUSTOM_TARGET(macro_built_in_functions ALL DEPENDS ${CMAKE_BINARY_DIR}/share/metview/etc/macro_built_in_functions.txt)


#$(dict): ../$(STARTUP_SCRIPT)   generate_dictionary.mv  ../bin/macro ../bin/macro regenerate_object_list ../share/metview/etc/ObjectListAll
#	../$(STARTUP_SCRIPT) -b generate_dictionary.mv $(dict)


ADD_CUSTOM_COMMAND(
    OUTPUT  ${CMAKE_BINARY_DIR}/share/metview/etc/macro_icon_function_help.xml
    COMMAND ${FULL_STARTUP_SCRIPT_PATH} -b ${CMAKE_CURRENT_SOURCE_DIR}/../../../scripts/generate_icon_fun_help.mv ${dict_file} ${CMAKE_BINARY_DIR}/share/metview/etc/macro_icon_function_help.xml
    DEPENDS ${FULL_STARTUP_SCRIPT_PATH} ${dict_file} ${metview_core_targets}
)

ADD_CUSTOM_TARGET(macro_built_in_functions ALL DEPENDS ${CMAKE_BINARY_DIR}/share/metview/etc/macro_built_in_functions.txt
                                                       ${CMAKE_BINARY_DIR}/share/metview/etc/dict.txt
                                                       ${CMAKE_BINARY_DIR}/share/metview/etc/macro_icon_function_help.xml
                                                       ${CMAKE_BINARY_DIR}/share/metview/etc/)

#$(icon_function_help): $(dict) ../$(STARTUP_SCRIPT)   generate_icon_fun_help.mv ../bin/macro regenerate_object_list ../share/metview/etc/ObjectListAll
#	../$(STARTUP_SCRIPT) -b generate_icon_fun_help.mv $(icon_function_help)


list(APPEND generated_files   macro_built_in_functions.txt dict.txt macro_icon_function_help.xml)



#if (METVIEW_MARS_ODB)
#    list(APPEND files MarsOdbDef MarsOdbRules)
#endif()


# a macro to generate derived Mars definition and rules files
macro(generate_def_file
      generated_file source_file verb_extension appl_extension)

    add_custom_command(
        OUTPUT ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/${generated_file}
	    COMMAND cat ${CMAKE_CURRENT_SOURCE_DIR}/${source_file} | sed 's/RETRIEVE[^D]/RETRIEVE${verb_extension} /g' | sed 's/READ /READ${verb_extension} /g' | sed 's/marsG2 /mars${appl_extension} /g' > ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/${generated_file}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${source_file})
    #add_custom_target(${generated_file} DEPENDS ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/${generated_file})

    list(APPEND generated_files ${generated_file})
    list(APPEND dependencies  ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/${generated_file})

endmacro(generate_def_file)

if(HAVE_PPROC_MIR)
    generate_def_file(MarsMirDef     ecmwf.def _MIR MIR)
    generate_def_file(MarsMirRules   mars.chk  _MIR MIR)
endif()

generate_def_file(MarsTiggeDef   tigge.def _TIGGE TIGGE)
generate_def_file(MarsTiggeRules mars.chk  _TIGGE TIGGE)

if (METVIEW_MARS_ODB)
    generate_def_file(MarsOdbDef   ecmwf.def _ODB ODB)
    generate_def_file(MarsOdbRules mars.chk  _ODB ODB)
endif()


#if (METVIEW_ECREGRID)
#    generate_def_file(MarsEcRegridDef  ecmwf.def _ECREGRID)
#    generate_def_file(MarsEcRegridRules mars.chk _ECREGRID)
#endif()



# Set up ConfigDef to have the network proxy settings given to CMake
configure_file(ConfigDef.in ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/ConfigDef @ONLY)

list(APPEND generated_files ConfigDef)



# at configure time we can just copy most of the files across to the build directory
foreach( f ${files} )
    # copy to the build directory
    configure_file(${f} ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/ COPYONLY)
endforeach()



# add all these to the list of files to be installed
foreach( f ${files} ${generated_files})
    # ensure file is installed at install time
    install( FILES ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/${f}  
             DESTINATION share/metview/etc
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)
endforeach()



# concatenate all object spec files into one
# remove all comments
# add "cat <<@ " as the first line, and "@" as the last
#message(STATUS "ModuleObjectSpecFiles: ${ModuleObjectSpecFiles}")

set(ObjectListAllComponents
       ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/Services
       ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/ObjectList
       ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/uPlotTable
       ${ModuleObjectSpecFiles})


add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/ObjectListAll
	COMMAND cat ${CMAKE_CURRENT_SOURCE_DIR}/${MARS_ACCESS} > ObjectListAll.temp \; echo 'cat <<\@'   >> ObjectListAll.temp \; cat ${ObjectListAllComponents} >> ObjectListAll.temp \; echo '\@'          >> ObjectListAll.temp \; grep -v "^#" ObjectListAll.temp > ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/ObjectListAll \; rm -f ObjectListAll.temp
#	COMMAND cat $(MARS_ACCESS) > ObjectListAll.temp \; echo "cat <<@ "   >> ObjectListAll.temp \; cat Services ObjectList uPlotTable >> ObjectListAll.temp \; cat `ls  ObjectSpec.* | grep -v \~`  >> ObjectListAll.temp \; echo "@"          >> ObjectListAll.temp \; grep -v '^#' ObjectListAll.temp > ObjectListAll
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/ObjectList ${ObjectListAllComponents})
add_custom_target(ObjectListAllTarget DEPENDS ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/ObjectListAll)


install( FILES ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/ObjectListAll
         DESTINATION share/metview/etc
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)


# add a target which will always be run. This will trigger the creation of the generated files if necessary
add_custom_command( 
    OUTPUT  defs_created.txt
    COMMAND touch defs_created.txt
    DEPENDS ${dependencies} ObjectListAllTarget
    )

add_custom_target( all_defs ALL DEPENDS defs_created.txt )

#Copy the tables to the build directory
foreach( d ${tables})
    add_custom_target(copy_all_tables ALL
    COMMAND cmake -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/${d} ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/${d}
    )
endforeach()

#Install the tables
foreach( d ${tables})
    install( DIRECTORY ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/etc/${d}/
         DESTINATION share/metview/etc/${d}
         FILE_PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
         DIRECTORY_PERMISSIONS OWNER_WRITE OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    )
endforeach()

=== debian/changelog ===
metview (5.1.0-2) unstable; urgency=medium

  * Update URLs in d/watch
  * Drop symlinks for libs no longer shipped. Closes: #904494.
  * Patch needed for Qt5 5.11 transition, which is stricter in C++ imports
  * Stricter version dependencies on qt5wekit, odb-api 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 26 Jul 2018 12:34:35 +0100

metview (5.1.0-1) unstable; urgency=medium

  * New upstream release
  * Drop ENABLE_QT5 from d/rules; no longer used
  * Set ODB_PATH=/usr
  * Standards-Version: 4.1.5

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 13 Jul 2018 21:06:12 +0100

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 10), 
  gfortran-8, 
  flex, 
  bison, 
  libhdf5-dev, 
  libpango1.0-dev, 
  libfftw3-dev,
  chrpath, 
  mksh,
  libqt5webkit5-dev (>= 5.212.0~alpha2-15), 
  qtbase5-dev, libqt5xmlpatterns5-dev,
  libeccodes-dev (>= 2.2.0),
  libeccodes-tools,
  libodb-api-dev (>= 0.18.0-5),
  libemos-dev (>= 2:4.1.1-2),  libemos-bin,
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev, 
  libmagics++-dev (>= 2.34.3-3),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkg-config,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libproj-dev, libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  cmake, 
  flextra, 
  libgeotiff-dev
Standards-Version: 4.1.5
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Browser: https://salsa.debian.org:/science-team/metview.git
Vcs-Git: https://salsa.debian.org:/science-team/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3
Recommends: magics++
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version})
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# DEB_LDFLAGS_MAINT_PREPEND:= -Wl,-z,defs -Wl,--as-needed
DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-format
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
export DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_PREPEND
export QT_SELECT=5
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) -std=c++11
UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

# Needed for sbuild. metview creates temp directories during build
export HOME:=/tmp
export METVIEW_LOCALHOST:=127.0.0.1
export METVIEW_DEBUG:=1
export FC:=gfortran-8

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
PATH:=$(PATH):$(CURDIR)/scripts
AUTOGENERATED:= libmetview-dev.install  metview.install libmetview0d.install libmetview0d.links
MV_DIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/metview
export METVIEW_DIR_DEV:=$(CURDIR)/debian/build
export METVIEW_BIN:=$(METVIEW_DIR_DEV)/bin
LC_ALL=C
TZ=UTC+0
export LC_ALL TZ

FPIC:= ''
ifeq ($(TARGET_ARCH), i386)
	FPIC:= -fPIC
endif

# magic debhelper rule
%:
	dh $@ --buildsystem=cmake --builddirectory=$(METVIEW_DIR_DEV) 

override_dh_auto_clean:
	dh_clean
	rm -rf $(METVIEW_DIR_DEV) src/images/metview.png
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	[ ! -f scripts/metview_base.in.bak ] || \
		( mv scripts/metview_base.in.bak scripts/metview_base.in )

# magics++ upstream ships with a copy of terralib, which is not used in Debian. 
# Instead we use # a shared terralib library, and so need to include terralib.
# Also -fPIC, for some reason.

override_dh_auto_configure:
	chmod +x ./scripts/*.mv
	# Hack. how to do this via ecbuild?
	cp scripts/metview_base.in scripts/metview_base.in.bak
	sed -e 's%@DEB_HOST_MULTIARCH@%${DEB_HOST_MULTIARCH}%g' < scripts/metview_base.in \
		> scripts/tmpx && mv scripts/tmpx scripts/metview_base.in
	dh_auto_configure -- \
		-DMETVIEW_SITE=debian  \
		-DCMAKE_BUILD_TYPE=Release \
		-DMETVIEW_EXTRA_LIBRARIES='terralib -lemosR64' \
		-DMETVIEW_EXTRA_INCLUDES='/usr/include/terralib/kernel' \
		-DMAGICS_HAVE_METVIEW=True \
		-DMAGICS_HAVE_NETCDF=True \
		-DMAGICS_PATH=/usr \
		-DBUILD_SHARED_LIBS=On \
		-DSKIP_INSTALL_RPATHS=On \
		-DENABLE_RPATHS=Off \
		-DENABLE_RELATIVE_RPATHS=Off \
		-DENABLE_ODB=On \
		-DODB_PATH=/usr \
		-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
		-DFLEXTRA_PATH=/usr/bin/flextra \
		-DDISABLE_OS_CHECK=On \
		-DFPIC=${FPIC}
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g'  < debian/CONFIG.site.in  | \
		sed -e 's%@UPSTREAM_VERSION@%${UPSTREAM_VERSION}%g' | \
		> $(METVIEW_DIR_DEV)/scripts/CONFIG.site 
	# These get generated ok on a machine with network connection, but fail on sbuilds, etc.
	# so copy pre-generated versions stored in etc
	mkdir -p debian/build/share/metview/etc/
	cp debian/etc/* debian/build/share/metview/etc/
	cd debian/build/share/metview/etc && $(MAKE) ObjectListAllTarget
	cp src/images/metview_logo.png src/images/metview.png

override_dh_auto_test:
	@echo "Checks disabled for the moment due to syntax errors in tests" 

override_dh_fixperms-arch:
	dh_fixperms
	rm -f debian/metview/usr/lib/*/metvidew/metview_post_install_tests.sh
	chmod 755 debian/metview/$(MV_DIR)/mv_compress
	chmod 644 debian/metview/$(MV_DIR)/metview_*.common
	chmod 644 debian/metview/$(MV_DIR)/metview_stat
	chmod 644 debian/metview/$(MV_DIR)/metview_patches
	chmod 644 debian/metview/usr/share/images/metview/*
	file debian/metview/$(MV_DIR)/* | grep ELF | cut -f1 -d: | xargs chrpath -d
	chrpath -d debian/libmetview0d/usr/lib/*/lib*so.0.0.0

override_dh_fixperms-indep:
	dh_fixperms
	rm -rf debian/metview-data/usr/share/applications
	find debian/metview-data/usr/share/metview -type f -exec chmod 644 {} \;
	find debian/metview-data/usr/share/metview -type d -exec chmod 755 {} \; 
	# Hack. Why weren't these already compressed -n ?
	gunzip debian/metview-data/usr/share/metview/app-defaults/Sample_Drawers.tar.gz
	gunzip debian/metview-data/usr/share/metview/app-defaults/User_Dir_Frame.tar.gz
	gzip -n debian/metview-data/usr/share/metview/app-defaults/Sample_Drawers.tar
	gzip -n debian/metview-data/usr/share/metview/app-defaults/User_Dir_Frame.tar
